import QtQuick 2.0

Rectangle {
    id: component

    width: 24
    radius: 12
    height: 235

    property color stepColor: "#ffd827"
    property int stepPerCent: 50

    border.width: 1
    border.color: "#ffffff"
    color: "transparent"

    function colorHue(color) {
        var cmax = Math.max(color.r, color.g, color.b);
        var cmin = Math.min(color.r, color.g, color.b);
        var delta = cmax - cmin;
        if (delta == 0)
            return 0;
        if (color.r == cmax)
            return (((color.g - color.b) % 6) / delta) / 6;
        if (color.g == cmax)
            return ((color.b - color.r) / delta + 2) / 6;
        return ((color.r - color.g) / delta + 4) / 6;
    }

    Rectangle {
        anchors {
            right: parent.right
            rightMargin: 5
            left: parent.left
            leftMargin: 5
            bottom: parent.bottom
            bottomMargin: 5
        }
        radius: 7
        height: stepPerCent / 100.0 * (parent.height - 10)
        gradient: Gradient {
            GradientStop { position: 0.0; color: Qt.hsla(component.colorHue(stepColor), 1, 0.6, 1) }
            GradientStop { position: 1.0; color: Qt.hsla(component.colorHue(stepColor), 0.2, 0.3, 1) }
        }
    }
}


