import QtQuick 2.0

Rectangle {
    id: component

    property Flickable scrollArea
    property alias clickable: mousearea.enabled
    readonly property alias handleX: handle.x
    readonly property alias handleWidth: handle.width

    clip: true
    height: 5
    color: "#1d1e2d"

    Rectangle {
        id: handle
        property bool verybig: scrollArea.visibleArea.widthRatio * component.width < 2

        anchors.top: parent.top
        anchors.bottom: parent.bottom

        x: scrollArea.visibleArea.xPosition * (component.width - (verybig ? 2 : 0))
        width: verybig ? 2 : scrollArea.visibleArea.widthRatio * component.width
        color: "#d3d2d9"
    }

    MouseArea {
        id: mousearea
        anchors.fill: parent
        onClicked: scrollArea.contentX = mouseX/width * scrollArea.contentWidth
    }

    visible: scrollArea.visibleArea.widthRatio < 1 && scrollArea.visible
}
