import QtQuick 2.0
import "." // QTBUG-34418, singletons require explicit import to load qmldir file

Item {
    id: idInter

    property bool interOn: false

    property alias backcolor: idRectangleOut.color
    property alias border: idRectangleOut.border
    property alias radius: idRectangleOut.radius
    property alias textcolor: idText.color

    width:200
    height:60

    Rectangle {
        id: idRectangleOut

        anchors.fill: parent

        color: UiConfig.colors.bg_active
        radius: 10
        border.color: UiConfig.colors.border

        Rectangle {
            id: idRectInter

            anchors.bottom: parent.bottom
            anchors.bottomMargin: idRectangleOut.border.width
            anchors.top: parent.top
            anchors.topMargin: idRectangleOut.border.width

            x: interOn ? idInter.width/2 : idRectangleOut.border.width
            width: parent.width/2 - idRectangleOut.border.width
            color: UiConfig.colors.bg_inactive
            radius: 10
            border.color: "#ffffff"

            Text {
                id: idText

                anchors.fill: parent

                color: idInter.enabled ? UiConfig.colors.fg_active : UiConfig.colors.fg_inactive
                text: config.autoTr + (interOn ? qsTr("ON") : qsTr("OFF"))
                font.bold: false
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 24
            }

            Behavior on x {
                NumberAnimation {
                    duration: 200
                }
            }
        }

        MouseArea {
            id: idMouseArea

            anchors.fill: parent

            onClicked: { interOn = !interOn; UiConfig.sound.play_click() }
        }
    }
}
