import QtQuick 2.0
import QtQuick.Controls 1.3
import "." // QTBUG-34418, singletons require explicit import to load qmldir file

Item {
    id: component

    StackView {
        id: stackview
        anchors.fill: parent

        initialItem: Qt.resolvedUrl("../page_accueil/page_accueil.qml")

        delegate: StackViewDelegate {
            pushTransition: StackViewTransition {
                PropertyAction {
                    target: enterItem
                    property: 'visible'
                    value: true
                }
                PropertyAction {
                    target: exitItem
                    property: 'visible'
                    value: false
                }
            }
            popTransition: pushTransition
        }

        invalidItemReplacement: Component {
            Page {
                title: "Page error"
                property string text
                Text {
                    anchors.centerIn: parent
                    anchors.verticalCenterOffset: -50
                    wrapMode: Text.WordWrap
                    horizontalAlignment: Text.AlignHCenter
                    text: config.autoTr + qsTr("Error occured while loading page...")
                    font.pixelSize: 22
                    color: UiConfig.colors.fg_root
                }
                onTextChanged: console.error("LoadingError: " + text)
            }
        }
    }

    Connections {
        target: stackview.currentItem
        onBack_page: stackview.pop()
        onHome_page: {stackview.pop(null);}
        onChange_page: stackview.push(Qt.resolvedUrl("../page_" + page + "/page_" + page + ".qml"), {'extra': extra})
    }
}
