import QtQuick 2.0
import "." // QTBUG-34418, singletons require explicit import to load qmldir file

Item {
    id: component
    property alias model: listview.model
    property alias scroll: scroll.scrollArea

    ListView {
        id: listview

        anchors.fill: parent
        anchors.leftMargin: 10

        clip: true
        spacing: 10
        snapMode: ListView.SnapToItem

        delegate: Loader {
            property variant modelData: model.modelData
            sourceComponent: modelData.type === "enum" ? enumDelegate :
                                                        modelData.type === "int" ? intDelegate : floatDelegate
        }
    }

    VScrollBar {
        id: scroll
        anchors {
            bottom: parent.bottom
            top: parent.top
            left: parent.left
        }
        scrollArea: listview
    }

    Component {
        id: intDelegate
        Row {
            spacing: 10
            Text {
                width: 250
                text: modelData ? modelData.name : ""
                font.pixelSize: 26
                color: UiConfig.colors.fg_root
                wrapMode: Text.WordWrap
            }
            Button {
                width: 300
                height: 60
                text: modelData ? modelData.text : ""
                font.pixelSize: 26

                onClicked: popup().editParam(modelData)
                enabled: modelData ? modelData.modifiable : false
            }
        }
    }
    Component {
        id: floatDelegate
        Row {
            spacing: 10
            Text {
                width: 250
                text: modelData ? modelData.name : ""
                font.pixelSize: 26
                color: UiConfig.colors.fg_root
                wrapMode: Text.WordWrap
            }
            Button {
                width: 300
                height: 60
                text: modelData ? modelData.text : ""
                font.pixelSize: 26

                onClicked: popup().editParam(modelData)
                enabled: modelData ? modelData.modifiable : false
            }
        }
    }
    Component {
        id: enumDelegate
        Row {
            spacing: 10
            Text {
                width: 250
                text: modelData ? modelData.name : ""
                font.pixelSize: 26
                color: UiConfig.colors.fg_root
                wrapMode: Text.WordWrap
            }
            Button {
                width: 300
                height: 60
                text: modelData ? modelData.text : ""
                font.pixelSize: 26

                onClicked: popup().editParam(modelData)
                enabled: modelData ? modelData.modifiable : false
            }
        }
    }
}
