import QtQuick 2.0

Item {
    property var _msg: null
    property var sequence: null
    property bool enable: true

    function open() {
        mindisplaytimer.restart();
        if (_msg === null)
        _msg = popup().msg(qsTr("Safety loop"), qsTr("Safety Loop is open"), [qsTr("OK")], function(nr) {
            if (nr !== undefined) {
                _msg = null;
                return true;
            }
            return false;
        });
    }

    function close() {
        mindisplaytimer.stop();
        _msg.close();
        _msg = null;
    }

    Connections {
        target: hal
        onSafetyLoopChanged: {
//            //console.log("securityLoopChanged: hal.setStartLight(", !remoteaccess.interfaceIsConnected && hal.safetyLoop, ")");
            hal.setStartLight(!remoteaccess.interfaceIsConnected && hal.safetyLoop);
//            //console.log("securityLoopChanged et enable = ", enable);
            if (_msg) {
                if (!mindisplaytimer.running && hal.safetyLoop)
                    close();
            } else {
                //Si on détecte l'ouverture ou la fermeture de la boucle et que enable est false c'est que l'ouverture est dûe à un arrêt volontaire du test. Dans ce cas pas de pop-up
//                //console.log("securityLoop: enable = ", enable);

            if (!hal.safetyLoop && enable){
                    if (sequence.isPlaying) {
                        sequence.abort();
                    }
                    open();
                }

            }
            //Mais les prochaines ouvertures ou fermetures elles devront être détectées.
            if(!enable) enable = true;
        }
    }
//    Connections {
//        target: process
//        onCommunicationError: {
//            if (_msg === null)
//                _msg = popup().msg(qsTr("Error"), qsTr("The test failed to launch."), [qsTr("OK")], function(nr) {
//                    if (nr !== undefined) {
//                        _msg = null;
//                        return true;
//                    }
//                    return false;
//                });
//        }
//    }

    Timer {
        id: mindisplaytimer
        interval: 2000
        onTriggered: if (_msg && hal.safetyLoop) close();
    }
}
