import QtQuick 2.2
import "." // QTBUG-34418, singletons require explicit import to load qmldir file

Item {
    id: idList

//    property alias test: idListView.test

//    property alias files: idListView.files

    property alias testloader: idListView.testloader

    property int maxElementToDisplay: 6
    property int elementHeight: 40

    property alias currentElement: idListView.currentIndex

    property alias backcolor: idRectangleOut.color
    property alias radius: idRectangleOut.radius
    property alias border: idRectangleOut.border

    property alias highlight: idListView.highlight

    property alias leftTitle: idLeftTitle.text
    property alias rightTitle: idRightTitle.text

    property color textcolor: UiConfig.colors.fg_active

    property bool validated: false

    property int scrollHeight: 0

    width: 300
    height: idRectangleOut.height + 2

//    ListModel {
//        id: idDefaultModel
//    }

    VScrollBar {
        id: vscoll
        anchors {
            top: idRectangleOut.top
            right: idRectangleOut.left
//            left: idRectangleOut.left
//            leftMargin: 10
            bottom: idRectangleOut.bottom
            margins: 6
        }
        width: 20
        scrollArea: idListView
    }

    Rectangle {
        id: idRectangleOut

        color: UiConfig.colors.bg_active
//        radius: 10
        border.color: "transparent" /*UiConfig.colors.border*/
        border.width: 2
        width: parent.width - 20
        height: /*(idList.maxElementToDisplay * idList.elementHeight) - 8*/idList.maxElementToDisplay * (idList.elementHeight -1)

        anchors.topMargin: idList.elementHeight

        Rectangle {
            id: idRectangleLeftTitle

            anchors {
//                bottom: idListView.top
                top: parent.top
                left: idListView.left
                right: idRectangleRightTitle.left
                rightMargin: -2
//                right: idRectangleRightTitle.left
            }

            color: UiConfig.colors.bg_active
    //        radius: 10
            border.color: UiConfig.colors.border
            border.width: 2
            width: (parent.width / 4)
            height: idList.elementHeight +2
            Text {
                id: idLeftTitle

                anchors.fill: parent

                color: "white"
                text: leftTitle
                font.pixelSize: 24
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
            }
        }

        Rectangle {
            id: idRectangleRightTitle

            anchors {
//                bottom: idListView.top
                top: parent.top
                right: idListView.right
//                left: idRectangleLeftTitle.right
            }

            color: UiConfig.colors.bg_active
    //        radius: 10
            border.color: UiConfig.colors.border
            border.width: 2
            width: 3* (parent.width / 4) + 2
            height: idList.elementHeight +2
            Text {
                id: idRightTitle

                anchors.fill: parent

                color: "white"
                text: rightTitle
                font.pixelSize: 24
                verticalAlignment: Text.AlignVCenter
                horizontalAlignment: Text.AlignHCenter
            }
        }

        ListView {
            id: idListView

//            property var files:0
//            property var test:0
            property var testloader: 0

            anchors.right: parent.right
            anchors.bottom: parent.bottom
            anchors.left: parent.left/*vscoll.right*/
            anchors.top: idRectangleRightTitle.bottom
//            anchors.rightMargin: 4
//            anchors.leftMargin: 4
//            anchors.bottomMargin: 4
            anchors.topMargin: -2

            snapMode: ListView.SnapToItem
            boundsBehavior: Flickable.StopAtBounds
            clip: true
            currentIndex: 0
            model: testloader.plcMemoryList
            highlightMoveDuration: 0

            spacing: -2

            delegate: Row{

//                anchors.centerIn: parent

                width: parent.width /*- 10*/
                height: idList.elementHeight + 18
                spacing:-2

                Rectangle {
                    id: indexRect
                    width: parent.width / 4
                    height: idList.elementHeight + 18
//                    left: parent.left
//                    radius:10

                    border.color: "#ffffff"
                    border.width: 2
                    color: "transparent"


                    Text {
                        id: idText1

                        anchors.fill: parent

                        color: "#b0b0b9"
                        text: index
                        font.pixelSize: 24
                        verticalAlignment: Text.AlignVCenter
                        horizontalAlignment: Text.AlignHCenter
                    }
                }

                Rectangle {
                    id: fileRect

                    width: 2 + parent.width / 2 + parent.width / 4
                    height: idList.elementHeight + 18
//                    right: parent.right
//                    radius:10
                    border.color: "#ffffff"
                    border.width: 2
                    color: "transparent"


                    Text {
                        id: idText

                        anchors.fill: parent

                        color: "#b0b0b9"
                        text: qsTr("<font color=\"%1\">%2</font>").arg(idList.textcolor).arg(modelData == "" ? qsTr("No File") : modelData)
                        font.pixelSize: 24
                        verticalAlignment: Text.AlignVCenter
                        horizontalAlignment: Text.AlignHCenter

                        MouseArea {
                            anchors.fill: parent

                            onClicked: {
                                scrollHeight =  vscoll.scrollArea.contentY;
                                popup().choose(qsTr("List of files"), testloader.filesList, 0 , function(nr) {
                                    if (nr !== undefined) {
                                        //console.log("popup.choose.function: index = ", index, " nr = ", nr, " model[index] = ", idListView.model[index], "  idList.list[nr].filename = ", testloader.filesList[nr]);
                                        testloader.setPlcMemory(index, testloader.filesList[nr]);
//                                        //console.log("memory[index] = ",test.plcMemoryList[index]);
                                    }
                                    return true;
                                });
                            }
                        }
                    }
                }

            }

            onModelChanged: {
                vscoll._setY(scrollHeight);
            }

        }
    }
}
