import QtQuick 2.0

Rectangle {
    id: component

    property Flickable scrollArea
    property alias clickable: mousearea.enabled
    readonly property alias handleY: handle.y
    readonly property alias handleHeight: handle.height

    clip: true
    width: 5
    color: "#1d1e2d"

    function _setY(ny) {
        scrollArea.contentY = ny;
    }

    Rectangle {
        id: handle
        property bool verybig: scrollArea.visibleArea.heightRatio * component.height < 2

        anchors.right: parent.right
        anchors.left: parent.left

        y: scrollArea.visibleArea.yPosition * (component.height - (verybig ? 2 : 0))
        height: verybig ? 2 : scrollArea.visibleArea.heightRatio * component.height
        color: "#d3d2d9"
    }

    MouseArea {
        id: mousearea
        anchors.fill: parent
        onClicked: scrollArea.contentY = mouseY/height * scrollArea.contentHeight
    }

    visible: scrollArea.visibleArea.heightRatio < 1 && scrollArea.visible
}
