import QtQuick 2.2
import QtQuick.Controls 1.0
import Horus 1.0
import "../HorusComponents"

Popup {
    id: legaldocbox

    property string title: ""    // Box title
    property string language: ""     // File to display
    property variant answers: [] // List of choices to display

    property var callback: null  // Callback called with the index of selected
                                 // answer or undefined if clicked on background
                                 // The callback should return true to let the
                                 // popup close itself
    property string textToDisplay: ""

    /** Function to wrap call to user's callback **/
    function _msg_callback_wrapper(nr) {
        if (!callback || callback(nr) === true)
            close();
    }

//    function readTextFile(fileUrl) {
//        var xhr = new XMLHttpRequest;
//        xhr.open("GET", fileUrl);
//        console.log("readTextFile non juste pour savoir si on y passe quoi ...");
//        xhr.onreadystatechange = function () {
//            if(xhr.readyState === XMLHttpRequest.DONE) {
//                var response = xhr.responseText;
////                textToDisplay = response;
//                console.log("readTextFile the text to display is : \n",response);
//                legal_text.text = response;
//                return response;
//            }
//        }
//        xhr.send();
//    }


    Rectangle {
        id: rectangleOut

        anchors.centerIn: parent

        color: UiConfig.colors.popup_bg
        radius: 10
        border.color: UiConfig.colors.popup_border

        width: 500
        height: 400

        MouseArea {
            anchors.fill: parent
            onClicked: {
                // Nothing to do
                // This MouseArea is present to catch click signals, to prevent
                // triggering the backgound MouseArea
            }
        }

        Column {
            id: column

            anchors.centerIn: parent

            width: parent.width - 20
            spacing: 10

            Text {
                width: parent.width
                text: title
                wrapMode: Text.Wrap
                color: UiConfig.colors.popup_fg_title
                horizontalAlignment: Text.AlignHCenter
                font.pixelSize: 35
                visible: text // Hide if text evaluates to false
            }

            Rectangle {
                id: file_rect
                width: legal_text.width + 10
                radius: 10
                height: rectangleOut.height - 150
                border.color: UiConfig.colors.popup_border
                color: "#23212e"

                ScrollView {
                    id: textZone
                    contentItem: legal_text
                    anchors.fill: parent
                    anchors.leftMargin: 10
                    anchors.rightMargin: 2
                    horizontalScrollBarPolicy: Qt.ScrollBarAlwaysOff

                    Text {
                        id : legal_text
                        width : 460
                        text: legalinfodisplayer.eulaText(language);
                        font.pixelSize: 15
                        wrapMode: Text.WordWrap
                        color: "white"
                    }
                }
            }

            Repeater {
                id: btnlst
                width: parent.width
                clip: true

                model: answers

                delegate: Button {
                    width: btnlst.width
                    height: txt.height + 20
                    onClicked: _msg_callback_wrapper(index)
                    text: ""

                    Text{
                        id: txt
                        anchors.centerIn: parent
                        width: parent.width - 20
                        text: answers[index]
                        color: "#ffffff"
                        wrapMode: Text.Wrap
                        font.bold: true
                        font.pixelSize: 20
                        horizontalAlignment: Text.AlignHCenter
                    }
                }
            }
        }
    }

    onClickedOut: {
//        _msg_callback_wrapper();
    }

}

