
/*
    Version modifiée par LN le 24/11/2016

    Modification : * Création du fichier
*/



import QtQuick 2.0
import "keys_private"
import "../HorusComponents"

Popup {
    id: numberEdit

    property string title: ""    // Popup title
    property real value: 0    // Initial value
    property string compvalue: "" //Value to compare
    property bool isHigh: true
    property var min: []        // List of minimal allowed
    property var max: []        // List of maximal allowed
    property string unit: ""    // Initial unit
    property var units: []       // List of units
    property var callback: null  // Callback called with the edited value or
                                 // undefined if clicked on background
                                 // The callback should return true to let the
                                 // popup close itself
    property bool padDisable: false

    property int _unitNb: 0

    /** Function to wrap call to user's callback **/
    function _msg_callback_wrapper(nr,ur) {
        // Ici soit l'utilisateur a validé sa saisie et celle-ci est correcte soit a appuyé en dehors de la pop up

        // Si l'utilisateur appui en dehors de la pop up alors on la ferme
        if (!callback)
            close();

        // Si l'utilisteur a validé sa saisie alors on ferme la pop up et on actualise la valeur
        else {

            close();
            callback(nr,ur);
        }

    }

    function validate_popup() {
        var userValue = numberInput.evaluateNumber();
        // Pour une raison inconnue il est nécessaire d'effectuer un *1000/1000 afin de bien prendre en compte toutes les digits du nombre
        var comp = numberEdit.compvalue*1000/1000;
        var high = numberEdit.isHigh;
        var unitlen = units.length;
        var unit = _unitNb;
        var userUnit = units[unit];
        var minstr = numberEdit.min[unit];
        var maxstr = numberEdit.max[unit];

//        //console.log("validate_popup :  isHigh = ", isHigh,  "  ,  userValue = ", userValue,"  , min = ", minstr, " max = ", maxstr);

        if ((userValue < numberEdit.min[unit]) || isNaN(userValue) || userValue > numberEdit.max[unit]) {
            minstr = minstr/*.toFixed(1)*/ + units[unit];
            maxstr = maxstr/*.toFixed(1)*/ + units[unit];

            popup().msg(qsTr("Value error"), qsTr("Value must be between %1 and %2").arg(minstr).arg(maxstr), [qsTr("Ok")], function(nr) {
                if (nr === 0) {
                    return true;
                }
            });
            return;
        }

        if (comp !== "") {
            ////console.log("validate_popup : isHigh = ", high);
            if (high === true) {
                ////console.log("validate_popup : true ? isHigh = ", high);
                ////console.log("validate_popup :  userValue (", userValue,") <  compvalue (", comp,") = ", (userValue < comp));
//                if(userValue < comp) {
//                     ////console.log("validate_popup :  userValue (", userValue,") <  compvalue (", comp,") = ", (userValue < comp));
//                    popup().msg(qsTr("Value error"), qsTr("High limit must be higher than low limit"), [qsTr("Ok")], function(nr) {
//                        if (nr === 0) {
//                            return true;
//                        }
//                    });
//                    return;
//                }
            }
            else if (high === false) {
                ////console.log("validate_popup : false ? isHigh = ", high);
                ////console.log("validate_popup :  userValue (", userValue,") >  compvalue (", comp,") = ",userValue > comp);
//                if(userValue > comp) {
//                    ////console.log("validate_popup :  userValue (", userValue,") >  compvalue (", comp,") = ",userValue > comp);
//                    popup().msg(qsTr("Value error"), qsTr("High limit must be higher than low limit"), [qsTr("Ok")], function(nr) {
//                        if (nr === 0) {
//                            return true;
//                        }
//                    });
//                    return;
//                }
            }
        }

        //popup().msg(qsTr("Test"), qsTr("userUnit = %1").arg(userUnit));
//        //console.log("validate_popup : uservalue = ", userValue);
        _msg_callback_wrapper(userValue, userUnit);
    }

    Text {
        anchors {
            top: rectangleOut.top
            left: rectangleOut.left
            leftMargin: 250
            right: rectangleOut.right
            rightMargin: 75
            bottom: rectangleOut.top
            bottomMargin: -82
        }
        text: title
        color: UiConfig.colors.popup_fg_title
        font.pixelSize: 40
        fontSizeMode: Text.Fit
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
        visible: text // Hide if text evaluates to false
    }

    Image {
        id: rectangleOut

        anchors.centerIn: parent

        source: "keys_private/KeypadUnits_bg.png"

        MouseArea {
            anchors.fill: parent
            onClicked: {
                // Nothing to do
                // This MouseArea is present to catch click signals, to prevent
                // triggering the backgound MouseArea
            }
        }

        Rectangle {
            id: numberZone

            anchors {
                top: parent.top
                topMargin: 11
                left: parent.left
                leftMargin: 25
            }

            height: 50
            width: 187

            border.color: numberInput.valid ? (numberInput.activeFocus ? "transparent" : "#000000") : UiConfig.colors.popup_bg_edit_ko
            border.width: 5
            radius: 8
            color: "transparent"

            TextInput {
                id: numberInput
                property bool _first_text_update: true
                property int _precision: -1
                property bool valid: true

                function evaluateNumber () {
                    var locale = Qt.locale();
                    var number = numberInput.text;
                    valid = ((number >= numberEdit.min[_unitNb]) && (number <= numberEdit.max[_unitNb]));

                    // Sélection de la zone de saisie lors de la première saisie
                    if (_first_text_update) {
                        _first_text_update = false;
                        numberInput.selectAll();
                    }
                    return number;
                }

                anchors.fill: parent

                focus: true

                text: {
                    var number = numberEdit.value;
                    console.log("TypeParamPopup: numberInput.text: number = ",numberEdit.value," et text = ",number.toString());
                    number.toString();
                }

                inputMethodHints: Qt.ImhDigitsOnly
                maximumLength: 10

                color: numberInput.valid ? UiConfig.colors.fg_active : UiConfig.colors.popup_bg_edit_ko
                selectionColor: "#66ffffff"
                selectByMouse: true
                cursorVisible: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                font.pixelSize: 26

                onTextChanged: evaluateNumber()
                onAccepted: numberEdit.validate_popup()
            }
        }
        MouseArea {
            anchors {
                top: parent.top
                bottom: parent.bottom
                right: parent.right
            }
            width: 74
            onClicked: clickedOut()
        }
        Keypad {
            id: keypad

            anchors {
                left: parent.left
                leftMargin: 17
                top: parent.top
                topMargin: 95
            }

            commaEnabled: _unitNb > 0
            minusEnabled: numberEdit.min < 0

            onValidated: numberEdit.validate_popup()

            PathView {
                id: unitsbox
                x: 432
                height: 100
                width: 130
                clip: true
                pathItemCount: 3
                currentIndex: _unitNb
                model: units

                function clicked(nr) {
                    if (nr === _unitNb)
                        return;
                    var v = numberInput.evaluateNumber();
                    numberEdit.value = v;
                    _unitNb = nr;
                    if (currentIndex != _unitNb) currentIndex = _unitNb
                }

                preferredHighlightBegin: 0.5
                preferredHighlightEnd: 0.5
                highlightRangeMode: PathView.StrictlyEnforceRange

                delegate: Text {
                    width: unitsbox.width
                    horizontalAlignment: Text.AlignHCenter
                    text: modelData
                    color: PathView.isCurrentItem ? UiConfig.colors.fg_active : "#c5c5cc"
                    MouseArea {
                        anchors.fill: parent
                        onClicked: unitsbox.clicked(index)
                    }
                }

                path: Path {
                    startX: unitsbox.width/2
                    startY: 0
                    PathLine { x: unitsbox.width/2; y: unitsbox.height; }
                }

                onMovementEnded: unitsbox.clicked(currentIndex)
                onModelChanged: if (currentIndex != _unitNb) currentIndex = _unitNb
                visible: units.length > 2
            }
            Item {
                x: 432
                height: 100
                width: 130
                visible: units.length <= 2
                Text {
                    y: 20
                    width: parent.width
                    visible: units.length >= 1
                    horizontalAlignment: Text.AlignHCenter
                    text: units[0]
                    color: _unitNb == 0 ? UiConfig.colors.fg_active : "#c5c5cc"
                    MouseArea {
                        anchors.fill: parent
                        onClicked: unitsbox.clicked(0)
                    }
                }
                Text {
                    y: 55
                    width: parent.width
                    visible: units.length == 2
                    horizontalAlignment: Text.AlignHCenter
                    text: units[1]
                    color: _unitNb == 1 ? UiConfig.colors.fg_active : "#c5c5cc"
                    MouseArea {
                        anchors.fill: parent
                        onClicked: unitsbox.clicked(1)
                    }
                }
            }
            KeyLargeNr {
                x: 431
                y: 110
                height: 100
                keyImage: "KeyReturn.png"
                onClicked: keypad.keypressed(12)
            }
        }
    }

    onClickedOut: {
        _msg_callback_wrapper();
    }

    Component.onCompleted: {
        if (unit !== units[_unitNb]) {
            var unitlen = units.length;
            while(_unitNb < unitlen && unit !== units[_unitNb])
            {
                _unitNb += 1;
            }
        }
        numberInput._first_text_update = true;
        numberInput.evaluateNumber();
        numberInput.forceActiveFocus(Qt.MouseFocusReason);
    }
}
