/*
    Version modifiée par LN le 24/11/2016

    Modification : * Ajout des paramètres d'une pop up d'unités pour les paramètres de limites de la fonction insulation
*/

//ES

function choose(title, model, currentElement, callback, replace) {
    var properties = {
        title: title,
        model: model,
        currentElement: currentElement,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("ChoosePopup.qml"), properties: properties, replace: replace });
}


function table(title, model, currentElement, callback, replace) {
    var properties = {
        title: title,
        model: model,
        currentElement: currentElement,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("AssociationPopup.qml"), properties: properties, replace: replace });
}

function manageFiles(title, model, currentElement, loader, testConfig, callback, replace) {
    var properties = {
        title: title,
        model: model,
        currentElement: currentElement,
        loader: loader,
        testConfig: testConfig,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("FilePopup.qml"), properties: properties, replace: replace });
}

function legalDoc(title, answers, language, callback, replace) {
    var properties = {
        title: title,
        answers: answers,
        language: language,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("LegalDocPopup.qml"), properties: properties, replace: replace });
}

function editNumber(title, defaultValue, min, max, unit, precision, callback, replace) {
    var properties = {
        title: title,
        value: defaultValue,
        unit: unit,
        min: min,
        max: max,
        precision: precision,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("KeypadPopup.qml"), properties: properties, replace: replace });
}

function editText(title, defaultText, callback, replace, regex) {
    var properties = {
        title: title,
        value: defaultText,
        callback: callback,
        regex: regex
    }
    return popupmgr.push({ item: Qt.resolvedUrl("KeyboardPopup.qml"), properties: properties, replace: replace });
}

function msg(title, message, answers, callback, replace) {
    var properties = {
        title: title,
        message: message,
        answers: answers,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("MessagePopup.qml"), properties: properties, replace: replace });
}

function progessMsg(title, message, answers, percent, callback, replace) {
    var properties = {
        title: title,
        message: message,
        answers: answers,
        progressPercent: percent,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("ProgressPopup.qml"), properties: properties, replace: replace });
}

function tempo(title, message, timing, callback, replace) {
    var properties = {
        title: title,
        message: message,
        timing: timing,
        callback: callback
    }
    return popupmgr.push({ item: Qt.resolvedUrl("TemporaryPopup.qml"), properties: properties, replace: replace });
}

function pushPopup(popupname, properties, replace) {
    return popupmgr.push({ item: popupname, properties: properties, replace: replace });
}

function editParam(param, callback, replace) {
    console.log("editParam: param.max = ", param.max);

    var type = param.type
    if (type === "int" || type === "float") {
        return editNumber(
                    param.name,
                    param.value,
                    param.min,
                    param.max,
                    param.unit,
                    type === "float" ? param.precision : 0,
                                      function (nr) {
                                          if (nr !== undefined) {
//                                              //console.log("function.js : nr = ", nr);
                                              param.value = nr;
//                                              //console.log("function.js : param.value = ", param.value);
                                              if (callback) callback(nr);
                                          }
                                          return true;
                                      });
    } else if (type === "enum") {
        return choose(
                    param.name,
                    param.enumNames,
                    param.value,
                    function(nr) {
                        if (nr !== undefined) {
                            param.value = nr;
                            if (callback)
                                callback(nr);
                        }
                        return true;
                    });
    } else if (type === "uA") {
        var properties = {
            title: param.name,
            value: param.row_value(),
//            compvalue: paramComp ? paramComp.row_value() : ((param.compValue !== undefined) ? param.compValue : param.max),
            compvalue: (param.compValue !== undefined) ? param.compValue : param.max + 1,
            isMax: param.isMax,
            min: param.min,
            max: param.max,
            units: param.units,
            callback: function(nr) {
                if (nr !== undefined) {
                    param.value = nr;
                    if (callback)
                        callback(nr);
                }
                return true;
            }
        };
        console.log("function.js: param.max = ", param.max);
        return popupmgr.push({ item: Qt.resolvedUrl("UnitsParamPopup.qml"), properties: properties, replace: replace });

    } else if (type === "choice"){
        var properties2 = {
            title: param.name,
            value: param.value,
//            compvalue: paramComp ? paramComp.value() : ((param.compValue !== undefined) ? param.compValue : param.max),
            compvalue: (param.compValue !== undefined) ? param.compValue : param.max + 1,
            isHigh: param.isHigh,
            min: [param.minOhm, param.minV],
            max: [param.maxOhm, param.maxV],
            unit: param.unit,
            units: param.choice,/*["mΩ", "V"],*/
            callback: function(nr, ur) {
                if (nr !== undefined) {
                    if(ur !== undefined){
                    param.unit = ur;
                    }
                    param.value = nr;

                    if (callback)
                        callback(nr, ur);
                }
                return true;
            }
        };
        return popupmgr.push({ item: Qt.resolvedUrl("TypeParamPopup.qml"), properties: properties2, replace: replace });
    }
}

function isOpened() {
    return popupmgr.opened;
}

function msgTest(title, message, answers, callback, replace) {
    var properties = {
        title: title,
        message: message,
        answers: answers,
        callback: callback
    }
    return popupmgrTest.push({ item: Qt.resolvedUrl("MessagePopup.qml"), properties: properties, replace: replace });
}
