import QtQuick 2.2

MouseArea {
    id: component

    property string text: ""
    property string keyImage: ""
    property alias radius: rect.radius
    property bool highlight: pressed

    enabled: text != ' '

    width: 56
    height: 56
    Rectangle {
        id: rect
        anchors.fill: parent
        radius: 5
        color: component.highlight ? "#b0b0b9" : "transparent"
        Text {
            anchors.fill: parent
            horizontalAlignment: Text.AlignHCenter
            verticalAlignment: Text.AlignVCenter
            text: component.keyImage ? "" : component.text
            color: component.highlight ? "#3a3a48" : "#ffffff"
            font.pixelSize: 30
            fontSizeMode: Text.Fit
        }
        Image {
            anchors.centerIn: parent
            source: component.keyImage
        }
    }
}
