import QtQuick 2.2
import "../../HorusComponents"
import "." // QTBUG-34418, singletons require explicit import to load qmldir file

Item {
    id: keypad
    property bool commaEnabled: true
    property bool minusEnabled: true
    property bool keysEnabled: true

    signal validated()

    function keypressed(nr) {
        UiConfig.sound.play_click()

        if (nr == 10) { // Comma
            kbed.sendCharacter (Qt.Key_Comma, /*Qt.locale().decimalPoint*/".", false, false);

        } else if (nr == 11) { // Backspace
            kbed.sendCharacter(Qt.Key_Backspace, "", false, false);

        } else if (nr == 12) { // Enter
            validated();

        } else {
            var character = nr;
            kbed.sendCharacter(character, character, false, false);
        }
    }

    Timer {
        id: keyRepeater
        property int keynr: -1
        interval: 100;
        running: keynr != -1;
        repeat: true
        onTriggered: keypressed(keynr)
    }

    Grid {
        columns: 3
        columnSpacing: 10
        rowSpacing: 7
        Repeater {
            model: 10
            delegate: KeyLargeNr {
                property int nb: index == 9 ? 0 : index + 1
                text: nb
                onReleased: keyRepeater.keynr = -1
                onPressAndHold: keyRepeater.keynr = nb
                onClicked: keypressed(nb)
                visible: keysEnabled
            }
        }
    }
    KeyLargeNr {
        x: 144
        y: 162
        text: /*Qt.locale().decimalPoint*/"."
        onReleased: keyRepeater.keynr = -1
        onPressAndHold: keyRepeater.keynr = 10
        onClicked: keypressed(10)
        visible: commaEnabled && keysEnabled
    }
    KeyLargeNr {
        x: 287
        y: 162
        keyImage: "KeyDel.png"
        onReleased: keyRepeater.keynr = -1
        onPressAndHold: keyRepeater.keynr = 11
        onClicked: keypressed(11)
        visible: keysEnabled
    }
}
