import QtQuick 2.2

Item {
    Timer {
        id:idTimer

        function update() {
            idHeaderDateText.text = Qt.formatDate(new Date(), config.dateFormat)
            idHeaderTimeText.text = Qt.formatTime(new Date(), "hh:mm:ss")
        }

        interval: 500
        running: true
        repeat: true

        onTriggered: update()
        Component.onCompleted: update()
    }

    Text {
        id: idHeaderDateText

        anchors.left: parent.left
        anchors.verticalCenter: parent.verticalCenter

        verticalAlignment: Text.AlignVCenter
        horizontalAlignment: Text.AlignHCenter

        color: "#37b478"
        font.pixelSize: 26
    }

    Text {
        id: idHeaderTimeText

        anchors.right: parent.right
        anchors.verticalCenter: parent.verticalCenter

        verticalAlignment: Text.AlignVCenter
        horizontalAlignment: Text.AlignHCenter

        color: idHeaderDateText.color
        font.pixelSize: idHeaderDateText.font.pixelSize
    }
}
