import QtQuick 2.0
import Horus 1.0

Item {
    Connections {
        target: step ? step : null
        ignoreUnknownSignals: true
        onAbortRequested: {
            step.process.measure_stop(false);
            step.finished(SequenceStep.StatusAborted);
            paramupdater.gndbond.enable = false;
        }
    }
    Connections {
        target: step && step.process ? step.process : null
        ignoreUnknownSignals: true
        onFinished: {
            var status = step.process.status;
            var finishedStatus = -1;

            if (status == GndBondProcess.PASS)
                finishedStatus = SequenceStep.StatusOK;
            else if (status == GndBondProcess.FAIL)
                finishedStatus = SequenceStep.StatusFAIL;
            else if (status == GndBondProcess.ERROR)
                finishedStatus = SequenceStep.StatusERROR;

            if (finishedStatus != -1) {
                step.process.measure_stop(false);
                paramupdater.gndbond.enable = false;
                step.finished(finishedStatus);
            }
        }
    }

    /*
        Version modifiée par LN le 12/01/2017
        Modification : * Voir gndbondstep.cpp
    */
    Component.onCompleted: {
        step.reset();
        step.process.halObj = hal;
        step.process.configObj = config;
        step.process.canbusGndBond = canbus.gndbond;
        paramupdater.gndbond.setEnable(true, step.programName);
        //step.process.measure_start();
    }
}
