import QtQuick 2.0
import Horus 1.0

Item {
    Connections {
        target: step ? step : null
        ignoreUnknownSignals: true
        onAbortRequested: {
            step.process.measure_stop(false);
            step.finished(SequenceStep.StatusAborted);
            paramupdater.picoammeter.enable = false;
        }
    }
    Connections {
        target: step && step.process ? step.process : null
        ignoreUnknownSignals: true
        onFinished: {
            var status = step.process.status;
            var finishedStatus = -1;

            if (status == PicoammeterProcess.PASS)
                finishedStatus = SequenceStep.StatusOK;
            else if (status == PicoammeterProcess.FAIL)
                finishedStatus = SequenceStep.StatusFAIL;
            else if (status == PicoammeterProcess.ERROR)
                finishedStatus = SequenceStep.StatusERROR;

            if (finishedStatus != -1) {
                step.process.measure_stop(false);
                paramupdater.picoammeter.enable = false;
                step.finished(finishedStatus);
            }
        }
    }
    Component.onCompleted: {
//        //console.log("picoammeter_glive.qml: onCompleted");
        step.reset();
        step.process.halObj = hal;
        step.process.configObj = config;
        step.process.canbusPicoammeter = canbus.picoammeter;
        paramupdater.picoammeter.setEnable(true, step.programName);
//        //console.log("picoammeter_glive.qml: onCompleted end");
//        step.process.measure_start();
    }
}
