import QtQuick 2.0
import "../HorusComponents"

Row {
    id: component
    property alias title: text.text
    property alias text: btn.text
    property string autoChangeAll: ""
    signal clicked()

    spacing: 10
    Text {
        id: text
        width: 220
        text: autoChangeAll ? gndbond.phase1[autoChangeAll].name : ""
        font.pixelSize: 26
        color: UiConfig.colors.fg_root
    }
    Button {
        id: btn
        width: 300
        height: 60
        font.pixelSize: 26

        text: {
            if (!autoChangeAll)
                return "";
            var ret = gndbond.phase1[autoChangeAll].text
            for (var i = 1; i < gndbond.nbPhases; ++i) {
                if (ret != gndbond.phases[i][autoChangeAll].text) {
                    return "-"
                }
            }
            return ret;
        }

        onClicked: {
            if (autoChangeAll) {
                popup().editParam(gndbond.phase1[autoChangeAll], function (nr) {
                    if (nr !== undefined) {
                        for (var i = 1; i < gndbond.nbPhases; ++i) {
                            if (gndbond.phases[i][autoChangeAll].type == "uA")
                                gndbond.phases[i][autoChangeAll].value = gndbond.phases[0][autoChangeAll].uA_value();
                            else
                                gndbond.phases[i][autoChangeAll].value = gndbond.phases[0][autoChangeAll].value;
                        }
                    }
                });
            }
            component.clicked()
        }
    }
}

