import QtQuick 2.2
import QtQuick.Controls 1.0
import Horus 1.0
import "../HorusComponents"


Page {
    id: gndbondParameters

    property variant gndbond: gndbondLoader.data

    title: config.autoTr + qsTr("Groundbond")
    headerButton {
        text: gndbondLoader.filename
        onClicked: {
            popup().editText(
                        qsTr("Filename"),
                        gndbondLoader.filename,
                        function (name) {
                            if (name !== undefined) {
                                if (gndbondLoader.exists(name)) {
                                    popup().msg(qsTr("Warning"), qsTr("There is already a configuration named \"%1\". Do you want to overwrite it ?").arg(gndbondLoader.data.sanitizeName(name)), [qsTr("Overwrite"), qsTr("Cancel")], function(nr) {
                                        if (nr === 0) {
                                            gndbondLoader.data.copyToStorage(name);
                                            config.gndbondConfig = name;
                                            return true;
                                        } else if (nr === 1) {
                                            return true;
                                        }
                                        return false;
                                    }, /* replace: */ true);
                                    return false;
                                } else {
                                    gndbondLoader.data.copyToStorage(name);
                                    config.gndbondConfig = name;
                                }
                            }
                            return (true);
                        }, false, "^[a-zA-Z0-9_-]+$");
        }
    }

    ParamGndBondLoader {
        id: gndbondLoader
        filename: config.gndbondConfig
    }

    Loader {
        id: innerpage
        anchors {
            top: parent.top
            bottom: parent.bottom
            left: parent.left
            right: rightColumn.left
            rightMargin: 10
        }
        source:  "auto.qml"
    }

    Column {
        id: rightColumn

        anchors {
            top: parent.top
            right: parent.right
            rightMargin: -10
        }

        spacing: 10

        ButtonList {
            helpText: config.autoTr + qsTr("This button opens file list parameters.")

            onClicked: {
                var nb = 0;
                for (nb in gndbondLoader.filesList) {
                    if (gndbondLoader.filesList[nb] == config.gndbondConfig)
                        break;
                    nb++;
                }
                msg = popup().manageFiles(qsTr("Change settings"), gndbondLoader.filesList, nb, gndbondLoader,
                function(nl) {
                    if (nl !== undefined) {
                        config.gndbondConfig = nl;
                    }
                },
                function(nr) {
                    return true;
                });
                disableButtons();

            }
        }

//        ButtonAddPhase {
//            enabled: gndbond.nbPhases < 7
//            visible: gndbond.mode.value === Paramgndbond.Auto
//            onClicked: gndbond.addPhase(innerpage.item.currentIndex)
//        }

//        ButtonRmPhase {
//            enabled: innerpage.item.currentIndex != 0 && gndbond.nbPhases > 3
//            visible: gndbond.mode.value === Paramgndbond.Auto
//            onClicked: gndbond.rmPhase(innerpage.item.currentIndex)
//        }

        ButtonHelp {
            helpText: config.autoTr + qsTr("This button opens help.")
        }

        ButtonPlay {
            helpText: config.autoTr + qsTr("This button opens live report back")
            onClicked: back_page()
        }
    }
}




