import QtQuick 2.0
import "../HorusComponents"

Button {
    id: component

    property string textTitle: ""
    property alias color: textzone.color

    rectVisible: false
    srcImage: "ErrorButton_normal.png"

    Rectangle {
        id: highlight
        anchors {
            top: parent.top
            topMargin: -border.width/2
            horizontalCenter: parent.horizontalCenter
        }
        width: parent.width + border.width
        height: parent.height + 20
        visible: false
        color: "transparent"
        radius: 16
        border.width: 3
    }

    Text {
        id: textzone
        property color colorTitle: parent.enabled ? "#fff" : UiConfig.colors.fg_inactive
        property int titleSize: textTitle.length > 10 ? 2 : 3
        anchors.fill: parent
        anchors.margins: 5

        text: '<font color="' + colorTitle + '" size="'+ titleSize + '">' + textTitle + '</font><br/>' + parent.text
        color: parent.enabled ? (parent.pressed ? UiConfig.colors.fg_pressed : UiConfig.colors.fg_active) : UiConfig.colors.fg_inactive

        fontSizeMode: Text.Fit
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter

        Behavior on color { ColorAnimation {} }
        Behavior on colorTitle { ColorAnimation {} }
    }

    states: [
        State {
            name: "error"
            PropertyChanges {
                target: highlight
                visible: true
                color: config.resultErrorColor
            }
            PropertyChanges {
                target: textzone
                color: "#fff"
                colorTitle: color
            }
        },
        State {
            name: "fail"
            PropertyChanges {
                target: highlight
                visible: true
                color: config.resultFailColor;
            }
            PropertyChanges {
                target: textzone
                color: "#fff"
                colorTitle: color
            }
        }
    ]
}
