import QtQuick 2.0
import Horus 1.0
import "../HorusComponents"

Column {
    property bool enabled_settings: true
    property bool enabled_list: true
    property bool enabled_help: true
    property bool stopMessage_visible: false
    property var filter: null
    property var msg: null

    property bool startStopRelated: false

    spacing: 10

    ButtonList {
        enabled: parent.enabled_list
        helpText: config.autoTr + qsTr("This button opens the parameters files list.")

        startRelated: startStopRelated

        onClicked: {
            function configHip(){
                return (hipotLoader.multiFlag ? config.multiHipotConfig : config.hipotConfig);
            }

            var nb = 0;
            for (nb in hipotLoader.filesList) {
                if (hipotLoader.filesList[nb] === configHip())
                    break;
                nb++;
            }
            msg = popup().manageFiles(qsTr("Change settings"), hipotLoader.filesList, nb, hipotLoader,
                  function(nl) {
                      if (nl !== undefined) {
                          if (hipotLoader.multiFlag) config.multiHipotConfig = nl;
                          else config.hipotConfig = nl;
                      }
                  },
                    function(nr) {
                        return true;
                    });
            disableButtons();
        }
    }

    ButtonHelp {
        //HelpDisable
        /*enabled: parent.enabled_help*/

        helpText: config.autoTr + qsTr("This button opens help.")

        startRelated: startStopRelated
        onClicked: helpdisplayer.setDoc("hipot")
    }

    ButtonSettings {
        dstLink: "hipot_parameters"
        dstExtra: {"loader": hipotLoader}
        enabled: parent.enabled_settings

        startRelated: startStopRelated

        helpText: config.autoTr + qsTr("This button opens hipot test settings.")
    }

//    Text {
//        id:tempHumRel
//        text: "\n\nT°C:" + '<font color="#fff">'+ "22" + '</font><br/>' + "\nHr%:" + '<font color="#fff">'+ "59" + '</font><br/>'
//        width: 55
//        font.pixelSize: 20
////        wrapMode: Text.WordWrap
//        color : "#ffd827"
//        visible: !parent.stopMessage_visible

//    }

    Connections {
        target: msg
        onClose: {
            hal.setStartLight(visible && !remoteaccess.interfaceIsConnected && hal.safetyLoop && !processQml.inhibit);
            hal.setStopLight(false);
        }
    }

    function disableButtons(){
        hal.setStartLight(false);
        hal.setStopLight(false);
    }
    Component.onCompleted: {
//        console.log("Hipot Right Bar onCompleted: loader = ", hipotLoader);
    }

}
