import QtQuick 2.0
import "../HorusComponents"

Row {
    id: component
    property alias title: text.text
    property alias text: btn.text
    property string autoChangeAll: ""
    signal clicked()

    spacing: 10
    Text {
        id: text
        width: 250
        text: autoChangeAll ? hipot.phase1[autoChangeAll].name : ""
        font.pixelSize: 26
        color: UiConfig.colors.fg_root
        wrapMode: Text.WordWrap
    }
    Button {
        id: btn
        width: 300
        height: 60
        font.pixelSize: 26

        text: {
            if (!autoChangeAll)
                return "";
            var ret = hipot.phase1[autoChangeAll].text
            var nbP = autoChangeAll === "voltage" ? hipot.nbPhases -1 : hipot.nbPhases;
            for (var i = 1; i < nbP; ++i) {
                if (ret !== hipot.phases[i][autoChangeAll].text) {
                    return "-"
                }
            }
            return ret;
        }
        enabled : {
            if (!autoChangeAll)
                return component.enabled;
            for (var i = 0; i < hipot.nbPhases; ++i) {
//                console.log("hipot.phases[",i,"][",autoChangeAll,"]")
                if (hipot.phases[i][autoChangeAll].modifiable) {
//                    console.log("hipot.phases[",i,"][",autoChangeAll,"].modifiable = true ");
                    return true;
                }
                else {
//                    console.log("hipot.phases[",i,"][",autoChangeAll,"].modifiable = false ");
                }
            }
            return false;
        }

        onClicked: {
            if (autoChangeAll) {
                var comp = hipot.phase1[autoChangeAll];

//                if (autoChangeAll === "imaxTotal" || autoChangeAll === "imaxReal") {
//                    var hname = (autoChangeAll === "imaxTotal" ? "iminTotal" : "iminReal");
//                    var highest = hipot.phase1[hname];
//                    for (var i = 1; i < hipot.nbPhases; ++i) {
//                     if(hipot.phases[i][hname].row_value() > highest.row_value()) highest = hipot.phases[i][hname];
//                    }
//                    comp = highest;
//                }

//                if (autoChangeAll === "iminTotal" ||  autoChangeAll === "iminReal") {
//                    var lname = (autoChangeAll === "iminTotal" ? "imaxTotal" : "imaxReal");
//                    var lowest = hipot.phase1[lname];
//                    for (var j = 1; j < hipot.nbPhases; ++j) {
//                     if(hipot.phases[j][lname].row_value() < lowest.row_value()) lowest = hipot.phases[j][lname];
//                    }
//                    comp = lowest;
//                }


                popup().editParam(hipot.phase1[autoChangeAll], function(nr){
                    if (nr !== undefined) {
                        if (autoChangeAll === "time" && hipot.phases[0][autoChangeAll].value === 0) {
                            popup().msg(qsTr("Value error"), qsTr("Holding phase can't last 0s as in phase"), [qsTr("Ok")]);
                            hipot.phases[0][autoChangeAll].value = 0.1;
                        }

                        for (var k = 1; k < hipot.nbPhases; ++k) {
                         if (hipot.phases[k][autoChangeAll].modifiable){
                            if (hipot.phases[k][autoChangeAll].type === "uA")
                                hipot.phases[k][autoChangeAll].value = hipot.phases[0][autoChangeAll].row_value();
                            else {
//                                console.log("hipot.phases[",k,"] [",autoChangeAll,"].value = ",hipot.phases[0][autoChangeAll].value);
                                hipot.phases[k][autoChangeAll].value = hipot.phases[0][autoChangeAll].value;
                            }
                            }
                        }
                    }
                    return true;
                });
            }
            component.clicked()
        }
    }
}

