import QtQuick 2.0
import Horus 1.0
import "../HorusComponents"

Column {
    property bool enabled_settings: true
    property bool enabled_list: true
    property bool enabled_help: true
    property bool stopMessage_visible: false
    property var filter: null
    property var msg: null

    property bool startStopRelated: false

    spacing: 10

    ButtonList {
        enabled: parent.enabled_list
        helpText: config.autoTr + qsTr("This button opens the parameters files list.")

        startRelated: startStopRelated

        onClicked: {
            var nb = 0;
            for (nb in megohmmeterLoader.filesList) {
                if (megohmmeterLoader.filesList[nb] === config.megohmmeterConfig)
                    break;
                nb++;
            }
            msg = popup().manageFiles(qsTr("Change settings"), megohmmeterLoader.filesList, nb, megohmmeterLoader,
            function(nl) {
                if (nl !== undefined) {
                    config.megohmmeterConfig = nl;
                }
            },
            function(nr) {
                return true;
            });
            disableButtons();

        }
    }

    ButtonHelp {
        //HelpDisable
        /*enabled: parent.enabled_help*/

        helpText: config.autoTr + qsTr("This button opens help.")

        startRelated: startStopRelated
        onClicked: helpdisplayer.setDoc("megohmmeter")
    }

    ButtonSettings {
        dstLink: "megohmmeter_parameters"
        enabled: parent.enabled_settings

        startRelated: startStopRelated

        helpText: config.autoTr + qsTr("This button opens megohmmeter test settings.")
    }

//    Text {
//        id:tempHumRel
//        text: "\n\nT°C:" + '<font color="#fff">'+ "22" + '</font><br/>' + "\nHr%:" + '<font color="#fff">'+ "59" + '</font><br/>'
//        width: 55
//        font.pixelSize: 20
////        wrapMode: Text.WordWrap
//        color : "#ffd827"
//        visible: !parent.stopMessage_visible

//    }

    Connections {
        target: msg
        onClose: {
            hal.setStartLight(visible && !remoteaccess.interfaceIsConnected && hal.safetyLoop && !processQml.inhibit);
            hal.setStopLight(false);
        }
    }

    function disableButtons(){
        hal.setStartLight(false);
        hal.setStopLight(false);
    }

}
