import QtQuick 2.2
import QtQuick.Controls 1.0
import Horus 1.0
import "../HorusComponents"


Page {
    id: megohmmeterParameters

    property variant megohmmeter: megohmmeterLoader.data

    title: config.autoTr + /*qsTr("Megohmmeter")*/qsTr("MΩ")
    headerButton {
        text: megohmmeterLoader.filename
        onClicked: {
            popup().editText(
                qsTr("Filename"),
                megohmmeterLoader.filename,
                function (name) {
                    if (name !== undefined) {
                        if (megohmmeterLoader.exists(name)) {
                            popup().msg(qsTr("Warning"), qsTr("There is already a configuration named \"%1\". Do you want to overwrite it ?").arg(megohmmeterLoader.data.sanitizeName(name)), [qsTr("Overwrite"), qsTr("Cancel")], function(nr) {
                                if (nr === 0) {
                                    megohmmeterLoader.data.copyToStorage(name);
                                    config.megohmmeterConfig = name;
                                    return true;
                                } else if (nr === 1) {
                                    return true;
                                }
                                return false;
                            }, /* replace: */ true);
                            return false;
                        }
                        else {
                            popup().msg(qsTr("Rename"), qsTr("Do you want to rename \"%1\" or do you want to duplicate \"%1\" and rename it ?").arg(config.megohmmeterConfig), [qsTr("Rename"), qsTr("Duplicate & Rename")], function(nr) {
                                if (nr === 1) {
                                    megohmmeterLoader.data.copyToStorage(name);
                                    config.megohmmeterConfig = name;
                                    return true;
                                } else if (nr === 0) {
                                    megohmmeterLoader.data.copyToStorage(name);
                                    megohmmeterLoader.remove(config.megohmmeterConfig);
                                    config.megohmmeterConfig = name;
                                    return true;
                                }
                                return false;
                            }, /* replace: */ true)
                        }
                    }
                    return (true);
                }, false, "^[a-zA-Z0-9_-]{1,100}$");
        }
    }

    ParamMegohmmeterLoader {
        id: megohmmeterLoader
        filename: config.megohmmeterConfig
    }

    Loader {
        id: innerpage
        anchors {
            top: parent.top
            bottom: parent.bottom
            left: parent.left
            right: rightColumn.left
            rightMargin: 10
        }
        source: /*megohmmeter.mode.value === ParamMegohmmeter.Auto ?*/ "auto.qml" /*: "manual.qml"*/ // TODO: mettre le mode permanent
    }

    Column {
        id: rightColumn

        anchors {
            top: parent.top
            right: parent.right
            rightMargin: -10
        }

        spacing: 10

        ButtonList {
            helpText: config.autoTr + qsTr("This button opens the paramters files list.")

            onClicked: {
                var nb = 0;
                for (nb in megohmmeterLoader.filesList) {
                    if (megohmmeterLoader.filesList[nb] === config.megohmmeterConfig)
                        break;
                    nb++;
                }
                msg = popup().manageFiles(qsTr("Change settings"), megohmmeterLoader.filesList, nb, megohmmeterLoader,
                function(nl) {
                    if (nl !== undefined) {
                        config.megohmmeterConfig = nl;
                    }
                },
                function(nr) {
                    return true;
                });
                disableButtons();

            }
        }

        ButtonHelp {
            helpText: config.autoTr + qsTr("This button opens help.")
        }

        ButtonPlay {
            helpText: config.autoTr + qsTr("This button opens live report back.")
            onClicked: back_page()
        }
    }
}




