import QtQuick 2.2
import QtQuick.Controls 1.0
import Horus 1.0
import "../HorusComponents"


Page {
    id: picoammeterParameters

    property variant picoammeter: picoammeterLoader.data

    title: config.autoTr + /*qsTr("Picoammeter")*/qsTr("pA")
    headerButton {
        text: picoammeterLoader.filename
        onClicked: {
            popup().editText(
                        qsTr("Filename"),
                        picoammeterLoader.filename,
                        function (name) {
                            if (name !== undefined) {
                                if (picoammeterLoader.exists(name)) {
                                    popup().msg(qsTr("Warning"), qsTr("There is already a configuration named \"%1\". Do you want to overwrite it ?").arg(picoammeterLoader.data.sanitizeName(name)), [qsTr("Overwrite"), qsTr("Cancel")], function(nr) {
                                        if (nr === 0) {
                                            picoammeterLoader.data.copyToStorage(name);
                                            config.picoammeterConfig = name;
                                            return true;
                                        } else if (nr === 1) {
                                            return true;
                                        }
                                        return false;
                                    }, /* replace: */ true);
                                    return false;
                                }
                                else {
                                    popup().msg(qsTr("Rename"), qsTr("Do you want to rename \"%1\" or do you want to duplicate \"%1\" and rename it ?").arg(config.picoammeterConfig), [qsTr("Rename"), qsTr("Duplicate & Rename")], function(nr) {
                                        if (nr === 1) {
                                            picoammeterLoader.data.copyToStorage(name);
                                            config.picoammeterConfig = name;
                                            return true;
                                        } else if (nr === 0) {
                                            picoammeterLoader.data.copyToStorage(name);
                                            picoammeterLoader.remove(config.picoammeterConfig);
                                            config.picoammeterConfig = name;
                                            return true;
                                        }
                                        return false;
                                    }, /* replace: */ true)
                                }
                            }
                            return (true);
                        }, false, "^[a-zA-Z0-9_-]{1,100}$");
        }
    }

    ParamPicoammeterLoader {
        id: picoammeterLoader
        filename: config.picoammeterConfig
    }

    Loader {
        id: innerpage
        anchors {
            top: parent.top
            bottom: parent.bottom
            left: parent.left
            right: rightColumn.left
            rightMargin: 10
        }
        source: /*picoammeter.mode.value === ParamPicoammeter.Auto ?*/ "auto.qml" /*: "manual.qml"*/ // TODO: mettre le mode permanent
    }

    Column {
        id: rightColumn

        anchors {
            top: parent.top
            right: parent.right
            rightMargin: -10
        }

        spacing: 10

        ButtonList {
            helpText: config.autoTr + qsTr("This button opens the paramters files list.")

            onClicked: {
                var nb = 0;
                for (nb in picoammeterLoader.filesList) {
                    if (picoammeterLoader.filesList[nb] === config.picoammeterConfig)
                        break;
                    nb++;
                }
                msg = popup().manageFiles(qsTr("Change settings"), picoammeterLoader.filesList, nb, picoammeterLoader,
                function(nl) {
                    if (nl !== undefined) {
                        config.picoammeterConfig = nl;
                    }
                },
                function(nr) {
                    return true;
                });
                disableButtons();

            }
        }

        ButtonHelp {
            helpText: config.autoTr + qsTr("This button opens help.")
        }

        ButtonPlay {
            helpText: config.autoTr + qsTr("This button opens live report back.")
            onClicked: back_page()
        }
    }
}




