import QtQuick 2.4
import Horus 1.0

Item {
    Row {
        anchors.centerIn: parent
        state: parent.state
        spacing: 10

        Canvas {
            id: teststatus

            anchors.verticalCenter: parent.verticalCenter

            property string text: ""
            property color color
            property color shadow

            visible: false
            implicitWidth: metrics.width + 20
            implicitHeight: metrics.height + 20

            renderStrategy: Canvas.Threaded

            onPaint: {
                visible = false;
                var ctx = getContext("2d");
                ctx.reset();
                ctx.font = "40px Days";
                ctx.save();
                ctx.shadowColor = shadow
                ctx.shadowOffsetX = 0;
                ctx.shadowOffsetY = 0;
//                ctx.shadowBlur = 10;
                ctx.fillText(text,10,50);
                ctx.restore();
                ctx.lineWidth = 1.5;
                ctx.strokeStyle = "#ffffff"
                ctx.fillStyle = color
                ctx.fillText(text,10,50);
                ctx.strokeText(text,10,50)

                ctx.font = "40px Days";
                ctx.fillText(text,10,50);

                ctx.restore();
                ctx.lineWidth = 1.5;
                ctx.strokeStyle = "#ffffff"
                ctx.fillStyle = color
                ctx.font = "40px Days";
                ctx.fillText(text,10,50);
                ctx.strokeText(text,10,50);
            }

            onPainted: {
                visible = true;
             }

            onTextChanged: requestPaint()

            TextMetrics {
                id: metrics
                text: teststatus.text
                font.pixelSize: 40
            }
        }

//        Image {
//            id: image

//            anchors.verticalCenter: parent.verticalCenter

//            width: 55
//            height: 55

//            fillMode: Image.PreserveAspectFit

//            source: ""
//            visible: false
//        }

        states: [
            State {
                name: Sequence.SentenceOK // PASS
                PropertyChanges {
                    target: teststatus
                    text: config.autoTr + qsTr(" \u2713 PASS")
                    color: config.resultPassColor
                    shadow: config.resultPassColor
//                    visible: true
                }
//                PropertyChanges {
//                    target: image
//                    source: "pass.png"
//                    visible: true
//                }
            },
            State {
                name: Sequence.SentenceFAIL // FAIL
                PropertyChanges {
                    target: teststatus
                    text: config.autoTr + qsTr(" \u2715 FAIL")
                    color: config.resultFailColor
                    shadow: config.resultFailColor
//                    visible: true
                }
//                PropertyChanges {
//                    target: image
//                    source: "fail.png"
//                    visible: true
//                }
            },
            State {
                name: Sequence.SentenceERROR // ERROR
                PropertyChanges {
                    target: teststatus
                    text: config.autoTr + qsTr(" \u2715 ERROR")
                    color: config.resultErrorColor
                    shadow: config.resultErrorColor
//                    visible: true
                }
            }
        ]
    }
}
