import QtQuick 2.0
import Horus 1.0
import "condition_tr.js" as CondTr
import "../../HorusComponents"

Item {
    implicitHeight: column.height + 4
    Column {
        id: column
        y: 4
        spacing: 4
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Step to test")
                button {
                    id:btn1
                    startRelated: true
                    text: model.step.testedStepNr
                    onClicked: {
                        btn1.btnMsg = popup().editNumber(
                                    label,
                                    model.step.testedStepNr,
                                    1,
                                    10000,
                                    "",
                                    0,
                                    function (nr) {
                                        if (nr !== undefined) {
                                            model.step.testedStepNr = nr;
                                        }
                                        return true;
                                    });
                        btn1.disableButtons();
                    }
                }
                Button {
                    anchors.verticalCenter: parent.verticalCenter
                    srcImage: "../../HorusComponents/ButtonNext_next.png"
                    rectVisible: false
                    visible: model.step.testedStepNr > 0 && model.step.testedStepNr <= sequenceModel.count
                    onClicked: {
                        lv.edited = model.step.testedStepNr - 1;
                    }
                }
            }
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Test condition")
                button {
                    id: btn2
                    startRelated: true
                    text: CondTr.testCondition(model.step.testCondition)
                    onClicked: {
                        var choices = [
                                    CondTr.testCondition(0),
                                    CondTr.testCondition(1),
                                    CondTr.testCondition(2),
                                    CondTr.testCondition(3),
                                    CondTr.testCondition(4)
                                ];
                        btn2.btnMsg = popup().choose(label, choices, -1, function (nr) {
                            if (nr !== undefined) {
                                model.step.testCondition = nr;
                            }
                            return true;
                        });
                        btn2.disableButtons();
                    }
                }
            }
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Action if true")
                button {
                    id: btn3
                    startRelated: true
                    text: CondTr.goto(model.step.gotoOk)
                    onClicked: {
                        var choices = [
                                    CondTr.goto(-2),
                                    CondTr.goto(-1),
                                    "goto XX"
                                ];
                        btn3.btnMsg = popup().choose(label, choices, -1, function (nr) {
                            if (nr !== undefined) {
                                nr -= 2
                                if (nr == 0) {
                                    popup().editNumber(
                                                label,
                                                model.step.testedStepNr,
                                                1,
                                                10000,
                                                "",
                                                0,
                                                function (nr) {
                                                    if (nr !== undefined) {
                                                        model.step.gotoOk = nr;
                                                    }
                                                    return true;
                                                }, /* replace */ true);
                                } else {
                                    model.step.gotoOk = nr;
                                }
                            }
                            return true;
                        });
                        btn3.disableButtons();
                    }
                }
                Button {
                    anchors.verticalCenter: parent.verticalCenter
                    srcImage: "../../HorusComponents/ButtonNext_next.png"
                    rectVisible: false
                    visible: model.step.gotoOk > 0 && model.step.gotoOk <= sequenceModel.count
                    onClicked: {
                        lv.edited = model.step.gotoOk - 1;
                    }
                }
            }
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Action if false")
                button {
                    id: btn4
                    startRelated: true
                    text: CondTr.goto(model.step.gotoKo)
                    onClicked: {
                        var choices = [
                                    CondTr.goto(-2),
                                    CondTr.goto(-1),
                                    qsTr("goto XX")
                                ];
                        btn4.btnMsg = popup().choose(label, choices, -1, function (nr) {
                            if (nr !== undefined) {
                                nr -= 2
                                if (nr == 0) {
                                    popup().editNumber(
                                                label,
                                                model.step.testedStepNr,
                                                1,
                                                10000,
                                                "",
                                                0,
                                                function (nr) {
                                                    if (nr !== undefined) {
                                                        model.step.gotoKo = nr;
                                                    }
                                                    return true;
                                                }, /* replace */ true);
                                } else {
                                    model.step.gotoKo = nr;
                                }
                            }
                            return true;
                        });
                        btn4.disableButtons();
                    }
                }
                Button {
                    anchors.verticalCenter: parent.verticalCenter
                    srcImage: "../../HorusComponents/ButtonNext_next.png"
                    rectVisible: false
                    visible: model.step.gotoKo > 0 && model.step.gotoKo <= sequenceModel.count
                    onClicked: {
                        lv.edited = model.step.gotoKo - 1;
                    }
                }
            }
        }
    }
}
