import QtQuick 2.0
import Horus 1.0
import "../../HorusComponents"

Item {
    property var step: model.step
    implicitHeight: column.height + 4
    Column {
        id: column
        y: 4
        spacing: 4
        ParamGndBondLoader {
            id: gndbondLoader
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Gndbond program")
                button {
                    id: btn
                    startRelated: true
                    text: step ? step.programName : ""
                    onClicked: {
                        var nb = 0;
                        for (nb in gndbondLoader.filesList) {
                            if (gndbondLoader.filesList[nb] == step.programName)
                                break;
                            nb++;
                        }
                        btn.btnMsg = popup().choose(label, gndbondLoader.filesList, nb, function(nr) {
                            if (nr !== undefined) step.programName = gndbondLoader.filesList[nr];
                            return true;
                        });
                        btn.disableButtons();
                    }
                }
            }
        }
    }
}


