import QtQuick 2.0
import Horus 1.0

Item {
    Connections {
        target: step ? step : null
        ignoreUnknownSignals: true
        onAbortRequested: {
            console.log("gndbondmultipoints_glive.qml : onAbortRequested");
            step.abort();
            step.finished(SequenceStep.StatusAborted);
            paramupdater.gndbond.enable = false;
        }
    }
    Connections {
        property var _msg: null
        target: step && step.pointsList.playingProcess ? step.pointsList.playingProcess : null
        ignoreUnknownSignals: true
        onFinished: {
            var status = step.pointsList.playingProcess.status;
            var finishedStatus = -1;

            if (status == GndBondProcess.PASS)
                finishedStatus = SequenceStep.StatusOK;
            else if (status == GndBondProcess.FAIL)
                finishedStatus = SequenceStep.StatusFAIL;
            else if (status == GndBondProcess.ERROR)
                finishedStatus = SequenceStep.StatusERROR;

            if (finishedStatus != -1) {
                console.log("gndbondmultipoints_glive.qml : step.abort")
                step.stopPoint();
                paramupdater.gndbond.enable = false;
                console.log("gndbondmultipoints_glive.qml : step.remainingPoints = ", step.remainingPoints, " ET !step.pointsList.playingProcess.running = ", !step.pointsList.playingProcess.running)
                //Si il reste des points à faire
                if (step.remainingPoints /*&& step.pointsList.playingProcess.running*/) {
                    _msg = popup().msg(qsTr("Point %1").arg(step.points - step.remainingPoints +1), qsTr("Prepare your device for the next point testing") , [qsTr("Ready")], function() {
                        if (step) {step.finished(finishedStatus,SequenceStep.GotoSame);
                            console.log("gndbondmultipoints_glive : step.finished(",finishedStatus, ", ", SequenceStep.GotoSame, " )");}
                        return true;
                        })
                }
                else {step.finished(finishedStatus);
                console.log("gndbondmultipoints_glive : step.finished(",finishedStatus,")");}
            }
        }
    }

    /*
        Version modifiée par LN le 27/06/2017
        Modification: * On effectue plus les paramètrages de process dans cette partie du code mais directement lors de la création du graph pour cette étape de multipoints bien particulière
    */
//    Component.onCompleted: {
////        //console.log("gndbondMultiPoints_glive.qml : ", step.pointsList.playingProcess, ".halobj = hal; configObj = config & canbus = canbus");
////        //console.log("gndbondMultiPoints_glive.qml : step.playPoint = ", step.playPoint);
////        step.reset();
////        //console.log("gndbondmultipoints_glive.qml : step = ", step, " & step.processList = ", step.processList);
////        step.pointsList.playingProcess.halObj = hal;
////        step.pointsList.playingProcess.configObj = config;
////        step.pointsList.playingProcess.canbusGndBond = canbus.gndbond;
////        paramupdater.gndbond.setEnable(true, step.programName);
//        // Pour le test en multi point on effectue le measure_start plusieurs fois et pas seulement une fois au lancement de la step
//        //     Donc celui-ci est fait directement dans l'objet GndBondMultiPointStep
//        //step.process.measure_start();
//    }
}
