import QtQuick 2.0
import Horus 1.0
import "../../HorusComponents"

Item {
    property var step: model.step
    implicitHeight: column.height + 4
    Column {
        id: column
        y: 4
        spacing: 4
        ParamHipotLoader {
            id: hipotLoader
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Hipot program")
                button {
                    id: btn
                    startRelated: true
                    text: step ? step.programName : ""
                    onClicked: {
                        var nb = 0;
                        for (nb in hipotLoader.filesList) {
                            if (hipotLoader.filesList[nb] == step.programName)
                                break;
                            nb++;
                        }
                        btn.btnMsg = popup().choose(label, hipotLoader.filesList, nb, function(nr) {
                            if (nr !== undefined) {
                                step.programName = hipotLoader.filesList[nr];
                                if (step.process.parameters.mode.value === ParamHipot.Permanent){
                                    step.programName = hipotLoader.filesList[nb];
                                    popup().msg(qsTr("Program error"), qsTr("Sequence can't handle permanent test"), [qsTr("Ok")]);
                                }
                            }
                            return true;
                        });
                        btn.disableButtons();
                    }
                }
            }
        }
    }
    Component.onCompleted:{
//        console.log("hipot_edit.qml onCompleted : hipotLoader = ",hipotLoader);
    }
}
