import QtQuick 2.0
import Horus 1.0
import "../../HorusComponents"

Item {
    property var step: model.step
    implicitHeight: column.height + 4
    Column {
        id: column
        y: 4
        spacing: 4
        ParamInsulationLoader {
            id: insulationLoader
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Megohmmeter program")
                button {
                    id: btn
                    startRelated: true
                    text: step ? step.programName : ""
                    onClicked: {
                        var nb = 0;
                        for (nb in insulationLoader.filesList) {
                            if (insulationLoader.filesList[nb] == step.programName)
                                break;
                            nb++;
                        }
                        btn.btnMsg = popup().choose(label, insulationLoader.filesList, nb, function(nr) {
                            if (nr !== undefined) {
                                step.programName = insulationLoader.filesList[nr];
                                if (step.process.parameters.mode.value === ParamInsulation.Permanent){
                                    step.programName = insulationLoader.filesList[nb];
                                    popup().msg(qsTr("Program error"), qsTr("Sequence can't handle permanent test"), [qsTr("Ok")]);
                                }
                            }
                            return true;
                        });
                        btn.disableButtons();
                    }
                }
            }            
        }
    }
}
