import QtQuick 2.0
import Horus 1.0

Item {
    Connections {
        target: step ? step : null
        ignoreUnknownSignals: true
        onAbortRequested: {
//            //console.log("megohmmeter_glive: onAbortRequested");
            step.process.measure_stop(false);
            step.finished(SequenceStep.StatusAborted);
            paramupdater.megohmmeter.enable = false;
        }
    }
    Connections {
        target: step && step.process ? step.process : null
        ignoreUnknownSignals: true
        onFinished: {
            var status = step.process.status;
//            var eval = step.process.eval;
            var finishedStatus = -1;

            if (status == MegohmmeterProcess.PASS)
                finishedStatus = SequenceStep.StatusOK;
            else if (status == MegohmmeterProcess.FAIL)
                finishedStatus = SequenceStep.StatusFAIL;
            else if (status == MegohmmeterProcess.ERROR)
                finishedStatus = SequenceStep.StatusERROR;

            if (finishedStatus != -1) {
//                //console.log("megohmmeter_glive: step onFinished: status = ", finishedStatus);
                step.process.measure_stop(false);
                paramupdater.megohmmeter.enable = false;
                step.finished(finishedStatus);
            }
        }
    }
    Component.onCompleted: {
//        //console.log("megohmmeter_glive.qml: onCompleted: paramupdater.megohmmeter.setEnable(true, step.programName);");
        step.reset();
        step.process.halObj = hal;
        step.process.configObj = config;
        step.process.canbusMegohmmeter = canbus.can1500;
        paramupdater.megohmmeter.setEnable(true, step.programName);
//        //console.log("megohmmeter_glive.qml: onCompleted end");
//        step.process.measure_start();
    }
}
