import QtQuick 2.0
import Horus 1.0
import "../../HorusComponents"

Item {
    implicitHeight: column.height + 4
    property var msg: null
    ImportExportHelper {
        id: ieh
    }
    Column {
        id: column
        y: 4
        spacing: 4
//        ListSettingsGroup {
//            ListSettingsElement {
//                label: config.autoTr + qsTr("Title")
//                button {
//                    id: btn1
//                    startRelated: true
//                    text: config.autoTr + qsTr("Edit")
//                    onClicked: {
//                        btn1.btnMsg = popup().editText(
//                                    label,
//                                    model.step.msgTitle,
//                                    function (txt) {
//                                        if (txt != undefined) {
//                                            model.step.msgTitle = txt;
//                                        }
//                                        return true;
//                                    });
//                        btn1.disableButtons();
//                    }
//                }
//            }
//        }
        ListSettingsGroup {
            ListSettingsElement {
                label: config.autoTr + qsTr("PDF")
                button {
                    id: btn2
                    startRelated: true
                    text: config.autoTr + qsTr("Change")
                    onClicked: {

                        // List local files
                        var extensions = [".pdf", ".PDF"];
                        ieh.setDir("", "/media/USB1", "./sequence/files")
                        var localModel = ieh.localModel;
                        var displaylist = [];
                        var indexeslist = [];
                        for (var i in localModel) {
                            if (!localModel[i].local)
                                continue;
                            for (var j in extensions) {
                                var ext = extensions[j];
                                var name = localModel[i].name;
                                if (name.indexOf(ext, name.length - ext.length) !== -1) {
                                    displaylist.push(name);
                                    indexeslist.push(i);
                                }
                            }
                        }

                        // Open popup to choose in library
                        btn2.btnMsg = popup().pushPopup(
                                    Qt.resolvedUrl("librarypopup.qml"), {
                                        title: label,
                                        model: displaylist,
                                        currentElement: -1,
                                        callback: function(nr) {
                                            if (nr !== undefined) {

                                                // User wants to import to library
                                                if (nr == -1) {
                                                    var wasMounted = ieh.isMounted();
                                                    if (!wasMounted) ieh.mount();

                                                    // USB key mounted
                                                    if (ieh.isMounted()) {
                                                        ieh.setDir("", "/media/USB1", "./sequence/files")
                                                        var remoteModel = ieh.remoteModel;
                                                        var displaylist2 = [];
                                                        var indexeslist2 = [];
                                                        for (var i in remoteModel) {
                                                            if (!remoteModel[i].remote)
                                                                continue;
                                                            for (var j in extensions) {
                                                                var ext = extensions[j];
                                                                var name = remoteModel[i].name;
                                                                if (name.indexOf(ext, name.length - ext.length) !== -1) {
                                                                    displaylist2.push(name);
                                                                    indexeslist2.push(i);
                                                                }
                                                            }
                                                            popup().choose(label, displaylist2, -1, function(nr2) {
                                                                if (nr2 !== undefined) {
                                                                    var chosen = remoteModel[indexeslist2[nr2]];

                                                                    // Just copy to library
                                                                    if (!chosen.local) {
                                                                        // All right, change image in step
                                                                        if (chosen.restore()) {
                                                                            model.step.msgPdf = chosen.name;
                                                                            model.step.msgPage = 1;

                                                                        // Copy error => cancel
                                                                        } else {
                                                                            popup().msg(label, qsTr("Copy of image cannot be done. Operation canceled."), [qsTr("Ok")], function(nr) {
                                                                                if (nr === 0) {
                                                                                    return true;
                                                                                }
                                                                            });
                                                                        }

                                                                    // Oh, there is already something with this name in library
                                                                    } else {
                                                                        popup().msg(qsTr("Warning"), qsTr("There is already a document named \"%1\" in library. Do you want to overwrite it ?").arg(chosen.name), [qsTr("Overwrite"), qsTr("Cancel")], function(nr3) {
                                                                            if (nr3 === 0) {
                                                                                chosen.restore();
                                                                                model.step.msgPdf = chosen.name;
                                                                                model.step.msgPage = 1;
                                                                                return true;
                                                                            } else if (nr3 === 1) {
                                                                                return true;
                                                                            }
                                                                            return false;
                                                                        }, /* replace: */ true);
                                                                    }
                                                                }
                                                                if (!wasMounted) ieh.mount();
                                                                return true;
                                                            }, /* replace */ true);
                                                        }

                                                    // USB key not mounted
                                                    } else {
                                                        popup().msg(label, qsTr("USB key cannot be installed"), [qsTr("Ok")], function(nr) {
                                                            if (nr === 0) {
                                                                return true;
                                                            }
                                                        });
                                                    }

                                                // User has chosen inside the library
                                                } else {
                                                    var chosen = localModel[indexeslist[nr]];
                                                    model.step.msgPdf = chosen.name;
                                                    model.step.msgPage = 1;
                                                }
                                            }
                                            return true;
                                        }
                                    });
                        btn2.disableButtons();
                    }
                }
            }
        }
        ListSettingsGroup {
            visible: model.step.msgPdf !== ""
            ListSettingsElement {
                label: config.autoTr + qsTr("Page")
                button {
                    id: btn3
                    startRelated: true
                    text: model.step.msgPage
                    enabled: pdfinfo.nbPages > 1
                    onClicked: {
                        btn3.btnMsg = popup().editNumber(
                                    label,
                                    model.step.msgPage,
                                    1,
                                    pdfinfo.nbPages,
                                    "",
                                    0,
                                    function (nr) {
                                        if (nr !== undefined) {
                                            model.step.msgPage = nr;
                                        }
                                        return true;
                                    });
                        btn3.disableButtons();
                    }
                }
                PdfDecoder {
                    id: pdfinfo
                    path: "sequence/files/" + model.step.msgPdf
                }
            }
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: config.autoTr + qsTr("Temporisation")
                Inter {
                    width: 250
                    height: 50
                    interOn: step.tempo
                    onInterOnChanged: {
                        step.tempo = interOn;
                        interOn = Qt.binding(function() { return step.tempo; });
                    }
                }
            }
        }
        ListSettingsGroup {
            visible: step.tempo
            ListSettingsElement {
                label: qsTr("Pause")
                button {
                    id: btn
                    startRelated: true
                    text: qsTr("%1s").arg(model.step.pause)
                    onClicked: {
                        btn.btnMsg = popup().editNumber(
                                    label,
                                    model.step.pause,
                                    0,
                                    90,
                                    "s",
                                    1,
                                    function (nr) {
                                        if (nr != undefined) {
                                            model.step.pause = nr;
                                        }
                                        return true;
                                    });
                        btn.disableButtons();
                    }
                }
            }
        }
    }
}
