import QtQuick 2.0
import "../../HorusComponents"

Item {
    implicitHeight: column.height + 4
    Column {
        id: column
        y: 4
        spacing: 4
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Title")
                button {
                    id: btn1
                    startRelated: true
                    text: qsTr("Edit")
                    onClicked: {
                        btn1.btnMsg = popup().editText(
                                    label,
                                    model.step.msgTitle,
                                    function (txt) {
                                        if (txt != undefined) {
                                            model.step.msgTitle = txt;
                                        }
                                        return true;
                                    });
                        btn1.disableButtons();
                    }
                }
            }
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Message")
                button {
                    id: btn2
                    startRelated: true
                    text: qsTr("Edit")
                    onClicked: {
                        btn2.btnMsg = popup().editText(
                                    label,
                                    model.step.msgText,
                                    function (txt) {
                                        if (txt != undefined) {
                                            model.step.msgText = txt;
                                        }
                                        return true;
                                    });
                        btn2.disableButtons();
                    }
                }
            }
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: config.autoTr + qsTr("Temporisation")
                Inter {
                    width: 250
                    height: 50
                    interOn: step.tempo
                    onInterOnChanged: {
                        step.tempo = interOn;
                        interOn = Qt.binding(function() { return step.tempo; });
                    }
                }
            }
        }
        ListSettingsGroup {
            visible: step.tempo
            ListSettingsElement {
                label: qsTr("Pause")
                button {
                    id: btn
                    startRelated: true
                    text: qsTr("%1s").arg(model.step.pause)
                    onClicked: {
                        btn.btnMsg = popup().editNumber(
                                    label,
                                    model.step.pause,
                                    0,
                                    90,
                                    "s",
                                    1,
                                    function (nr) {
                                        if (nr != undefined) {
                                            model.step.pause = nr;
                                        }
                                        return true;
                                    });
                        btn.disableButtons();
                    }
                }
            }
        }
    }
}
