import QtQuick 2.4
import Horus 1.0

import QtQuick.Controls 1.3
import "../../HorusComponents"

//Item {
//    width: if (parent) parent.width
//    implicitHeight: 40
//    Text {
//        anchors.centerIn: parent
//        text: model.result == SequenceStep.StatusOK ? qsTr("Message confirmed") :
//              model.result == SequenceStep.StatusRunning ? qsTr("Waiting for message confirmation") :
//              qsTr("Message not yet displayed")
//        color: sequenceModel.playIndex == index ? UiConfig.colors.fg_root : "#707173"
//    }
//}

Item {

    id:item
    width: if (parent) parent.width
    implicitHeight: 290
    anchors.centerIn: if (parent) parent


    VScrollBar {
        anchors {
            top: parent.top
            bottom: parent.bottom
            right: parent.left
        }
        scrollArea: flickable
    }


    Flickable {
        id: flickable

        anchors.fill: parent
        anchors.topMargin: 20
        contentWidth: inner.width
        contentHeight: inner.height
        flickableDirection: Flickable.VerticalFlick
        interactive: inner.height > parent.height
        clip: true

        Column {
            id: inner
            spacing: 15
            height: title.height + message.height + 45

            Text {
                id: title
                width: item.width
                horizontalAlignment: Text.AlignHCenter
                anchors.topMargin: 20

                font.pixelSize: 30
                wrapMode: Text.Wrap
                text: step.msgTitle
                color: sequenceModel.playIndex == index ? UiConfig.colors.fg_root : "#707173"
            }

            Text {
                id: message
                width: item.width
                anchors.left: parent.left
                anchors.leftMargin: 10
                font.pixelSize: 20
                wrapMode: Text.Wrap
                text: step.msgText
                color: /*sequenceModel.playIndex == index ? UiConfig.colors.fg_root :*/ "#707173"
            }

//            Button {
//                id: btn
//                width: txt.width + 80
//                visible: model.result == SequenceStep.StatusRunning
//                height: txt.height + 20
//                anchors.horizontalCenter: parent.horizontalCenter
//                onClicked: model.step.confirm()
//                text: ""
//                Text {
//                    id: txt
//                    anchors.centerIn: parent
//                    text: qsTr("Ok")
//                    color: "#ffffff"
//                    wrapMode: Text.Wrap
//                    font.bold: true
//                    font.pixelSize: 25
//                    horizontalAlignment: Text.AlignHCenter
//                }
//            }
        }

    }
}
