import QtQuick 2.0
import "../../HorusComponents"

Item {
    implicitHeight: column.height + 4
    Column {
        id: column
        y: 4
        spacing: 4
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Goto")
                button {
                    id: btn1
                    startRelated: true
                    text: model.step.gotoStep
                    onClicked: {
                        btn1.btnMsg = popup().editNumber(
                                    label,
                                    model.step.gotoStep,
                                    1,
                                    10000,
                                    "",
                                    0,
                                    function (nr) {
                                        if (nr !== undefined) {
                                            model.step.gotoStep = nr;
                                        }
                                        return true;
                                    });
                        btn1.disableButtons();
                    }
                }
                Button {
                    anchors.verticalCenter: parent.verticalCenter
                    srcImage: "../../HorusComponents/ButtonNext_next.png"
                    rectVisible: false
                    visible: model.step.gotoStep > 0 && model.step.gotoStep <= sequenceModel.count
                    onClicked: {
                        lv.edited = model.step.gotoStep - 1;
                    }
                }
            }
        }
        ListSettingsGroup {
            ListSettingsElement {
                label: qsTr("Repeat count")
                button {
                    id: btn2
                    startRelated: true
                    text: model.step.repeats
                    onClicked: {
                        btn2.btnMsg = popup().editNumber(
                                    label,
                                    model.step.repeats,
                                    1,
                                    10000,
                                    "",
                                    0,
                                    function (nr) {
                                        if (nr !== undefined) {
                                            model.step.repeats = nr;
                                        }
                                        return true;
                                    });
                        btn2.disableButtons();
                    }
                }
            }
        }
    }
}
