import QtQuick 2.0
import "../HorusComponents"

Page {
    title: config.autoTr + qsTr("Display settings")
    saveImgVisible: false

    ButtonHelp {
        id: helpbutton

        anchors {
            top: parent.top
            right: parent.right
            rightMargin: -10
        }
    }

    ListSettings {
        anchors {
            top: parent.top
            left: parent.left
            bottom: parent.bottom
            right: helpbutton.left
            rightMargin: 10
        }

        /*************
        * Brightness *
        *************/
        ListSettingsElement {
            label: config.autoTr + qsTr("Brightness :")
            SliderImage {
                width: 250
                height: 40
                step: 6
                value: (hal.brightness - 1) / 6
                onValueChanged: {
                    hal.setBrightness(6 * value + 1)
                }
            }
        }

        /************
        * Pass test *
        ************/
        ListSettingsElement {
            label: config.autoTr + qsTr("Pass test :")
            SliderColor {
                width: 250
                color: config.resultPassColor
                onReleased: config.resultPassColor = color
            }
        }

        /************
        * Fail test *
        ************/
        ListSettingsElement {
            label: config.autoTr + qsTr("Fail test :")
            SliderColor {
                width: 250
                color: config.resultFailColor
                onReleased: config.resultFailColor = color
            }
        }

        /*************
        * Error test *
        *************/
        ListSettingsElement {
            label: config.autoTr + qsTr("Error :")
            SliderColor {
                width: 250
                color: config.resultErrorColor
                onReleased: config.resultErrorColor = color
            }
        }
    }
}
