import QtQuick 2.2
import Horus 1.0
import "../HorusComponents"

Page {
    title: config.autoTr + qsTr("Generator")

    saveImgVisible: false

    ButtonHelp {
        id: helpbutton
        anchors {
            top: parent.top
            right: parent.right
            rightMargin: -10
        }
    }

    ListSettings {
        id : ls
        anchors {
            top: parent.top
            left: parent.left
            bottom: parent.bottom
            right: helpbutton.left
            rightMargin: 10
        }

        /************
        * Generator *
        ************/
        ListSettingsElement {
            label: config.autoTr + qsTr("Generator :")
            List {
                id: idListInterface
                width: 250
                maxElementToDisplay: 4
                currentElement : config.powerSupply.value
                model: config.powerSupply.enumNames
                onCurrentElementChanged: config.powerSupply.value = currentElement
            }
        }


        /**********************
        * External Generator  *
        ***********************/
        ListSettingsGroup {
            visible: (idListInterface.currentElement === ParamGlobal.EXTERNAL)
            ListSettingsElement {
                showGroup: false
                label: config.autoTr + qsTr("Maximum Voltage :")
                button {
                    text: config.maxExtVoltage.value + config.maxExtVoltage.unit
                    onClicked: popup().editParam(config.maxExtVoltage)
                }
            }

            ListSettingsElement {
                showGroup: false
                label: config.autoTr + qsTr("Maximum Current :")
                button {
                    text: config.maxExtCurrent.value + config.maxExtCurrent.unit
                    onClicked: popup().editParam(config.maxExtCurrent)
                }
            }
        }



    }
}
