import QtQuick 2.0
import "../HorusComponents"

ListSettings {
    id: component
    signal validated();

    /***********
    * Language *
    ***********/
    Text {
        text: qsTr("Language :")
        font.pixelSize: 26
        color: UiConfig.colors.fg_root
    }
    List {
        property var codes: ["es", "fr", "de", "en", "cn", "ar", "ru"]

        model: ListModel {
            ListElement { name: qsTr("Español") }
            ListElement { name: qsTr("Francais") }
            ListElement { name: qsTr("Deutch") }
            ListElement { name: qsTr("English") }
            ListElement { name: qsTr("中國") }
            ListElement { name: qsTr( "العربية") }
            ListElement { name: qsTr("русский") }
        }

        onValidatedChanged: {
            if (validated) {
                config.language = codes[currentElement]
                refresh_page();
                validated = false;
                component.validated();
            }
        }

        Component.onCompleted: {
            var nr = -1;
            var lang = config.language;
            for (var i in codes)
                if (codes[i] == lang)
                    nr = i;
            currentElement = nr;
        }
    }
}
