import QtQuick 2.0
import "../HorusComponents"

Image {
    property int min: 0
    property int max: 5
    property int value: 0
    property int nbDigits: 2
    signal clicked(int index)

    id: box
    source: "box.png"
    PathView {
        id: pv
        anchors.fill: parent
        anchors.margins: 5
        clip: true
        pathItemCount: 5
        model: (box.max - box.min + 1)

        preferredHighlightBegin: 0.5
        preferredHighlightEnd: 0.5
        highlightRangeMode: PathView.StrictlyEnforceRange

        delegate: Text {
            width: box.width
            horizontalAlignment: Text.AlignHCenter
            text: ("0" + (box.min + index)).slice (-nbDigits)
            color: PathView.isCurrentItem ? UiConfig.colors.fg_active : "#c5c5cc"
            MouseArea {
                anchors.fill: parent
                onClicked: box.clicked(index)
            }
        }

        path: Path {
            startX: box.width/2
            startY: 0
            PathLine { x: box.width/2; y: box.height; }
        }

        onMovementEnded: box.clicked(currentIndex)
        onModelChanged: if (currentIndex != value - min) currentIndex = value - min
    }

    onValueChanged: if (pv.currentIndex != value - min) pv.currentIndex = value - min
}
