import QtQuick 2.2
import Horus 1.0
import "../HorusComponents"

Page {
    title: config.autoTr + qsTr("Screen Mirror")
    saveImgVisible: false

    ButtonHelp {
        id: helpbutton
        anchors {
            top: parent.top
            right: parent.right
            rightMargin: -10
        }
    }

    ListSettings {
        id : ls

        anchors {
            top: parent.top
            left: parent.left
            bottom: parent.bottom
            right: helpbutton.left
            rightMargin: 10
        }

        /************
        * Interface *
        ************/
        ListSettingsElement {
            label: config.autoTr + qsTr("Interface :")
            List {
                id: idListInterface
                width: 250
                maxElementToDisplay: 4
                currentElement : config.vncInterface.value
                model: config.vncInterface.enumNames
                onCurrentElementChanged: {
                    config.vncInterface.value = currentElement;
                    config.wifiVnc = (currentElement!==0);
                    hal.setVnc(config.wifiVnc);
                }
            }
        }
    }
}
