#!/bin/bash

FAIL_USB=2
FAIL_ARCHIVE=3
FAIL_SCRIPT=4
SUCCESS=5
FAIL_UNKNOWN=6
FAIL_PRESCRIPT=7

MOUNT_PATH=/mnt
USB_DEV1=/dev/sda1
USB_DEV2=/dev/sda
MAJ_PATH=/media/writable/update
MAJ_FILE=eaton-maj.sh
PRESCRITP_FILE=eaton-prescript.sh
ZIP_FILE=eaton-maj.zip

function fail(){
	FAIL=$1
	umount $MOUNT_PATH
	exit $FAIL
}


function pass(){
	umount $MOUNT_PATH
	exit $SUCCESS
}


#mountage de la clef usb de mise a jour
if ! mount $USB_DEV1 $MOUNT_PATH
then 
	if ! mount $USB_DEV2 $MOUNT_PATH
	then
		echo "Probleme USB"
		fail $FAIL_USB
	fi
fi

mkdir -p $MAJ_PATH
#Extraction automatique de l’archive de mise à jour dans le répertoire de mise à jour dans la mémoire interne
if ! unzip $MOUNT_PATH/$ZIP_FILE -d $MAJ_PATH
then
	echo "probleme d'archive"
	fail $FAIL_ARCHIVE
fi

#Vérification de la présence d’un script de mise à jour dans l’archive de mise à jour
if ! [ -f $MAJ_PATH/$MAJ_FILE ]
then
	echo "probleme de script"
	fail $FAIL_SCRIPT
fi

#le script est présent : mode d'execution
if ! chmod a+x $MAJ_PATH/$MAJ_FILE
then 
	echo "probleme de script"
	fail $FAIL_SCRIPT
fi

#Vérification de la présence d’un prescript dans l’archive de mise à jour
if [ -f $MAJ_PATH/$PRESCRITP_FILE ]
then
	chmod a+x ./$MAJ_PATH/$PRESCRITP_FILE 
	if $MAJ_PATH/$PRESCRITP_FILE 
	then
		fail $FAIL_PRESCRIPT
	fi
fi

pass

