#!/bin/bash

FAIL_USB=2
FAIL_ARCHIVE=3
FAIL_SCRIPT=4
WORKING=1
FAIL_UNKNOWN=6
FAIL_PRESCRIPT=7

MOUNT_PATH=/mnt
USB_DEV1=/dev/sda1
USB_DEV2=/dev/sda
MAJ_PATH=/media/writable/update
MAJ_FILE1=kernel.hex
ZIP_FILE=eaton-maj-fct.zip

function fail(){
	FAIL=$1
	umount $MOUNT_PATH
echo $FAIL
	exit $FAIL
}


function pass(){
	umount $MOUNT_PATH
echo $WORKING
	exit $WORKING
}


#mountage de la clef usb de mise a jour
if ! mount $USB_DEV1 $MOUNT_PATH
then 
	if ! mount $USB_DEV2 $MOUNT_PATH
	then
		echo "Probleme USB"
		fail $FAIL_USB
	fi
fi

mkdir -p $MAJ_PATH
#Extraction automatique de l’archive de mise à jour dans le répertoire de mise à jour dans la mémoire interne
if ! unzip -o $MOUNT_PATH/$ZIP_FILE -d $MAJ_PATH
then
	echo "probleme d'archive"
	fail $FAIL_ARCHIVE
fi

pass

